From 7a8d6257b57e5e9a297a5cd75b1265b33f9a7f85 Mon Sep 17 00:00:00 2001
From: skrzepto <shims506@gmail.com>
Date: Jun 21 2016 17:36:14 +0000
Subject: [PATCH 499/1001] adding unittests to model modification


removed the long comment

---

diff --git a/hubs/models.py b/hubs/models.py
index ee52937..681048b 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -306,6 +306,10 @@ class Widget(BASE):
     def by_plugin(cls, session, plugin):
         return session.query(cls).filter_by(plugin=plugin).first()
 
+    @classmethod
+    def by_hub_id_all(cls, session, hub_id):
+        return session.query(cls).filter_by(hub_id=hub_id).all()
+
     get = by_idx
 
     @property
diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
new file mode 100644
index 0000000..c836a51
--- /dev/null
+++ b/hubs/tests/test_models.py
@@ -0,0 +1,98 @@
+import hubs
+import hubs.models
+import hubs.tests
+import fedmsg.config
+
+fedmsg_config = fedmsg.config.load_config()
+
+
+class ModelTest(hubs.tests.APPTest):
+    def test_delete_user(self):
+        self.session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
+
+        # verify user exists
+        username = 'ralph'
+        openid = '%s.id.fedoraproject.org' % username
+        user = hubs.models.User.get(self.session, openid)
+        self.assertIsNotNone(user)
+
+        # check if association exists
+        hub = hubs.models.Hub.get(self.session, username)
+        assoc = hubs.models.Association.get(self.session, hub, user, 'owner')
+        self.assertIsNotNone(assoc)
+
+        # delete the user
+        self.session.delete(user)
+        user = hubs.models.User.get(self.session, openid)
+        self.assertIsNone(user)
+
+        # checking to see if the hub is still intact
+        hub = hubs.models.Hub.get(self.session, username)
+        self.assertIsNotNone(hub)
+        self.assertEqual('ralph', hub.name)
+
+        # check if widgets still are intact
+        widgets = hubs.models.Widget.by_hub_id_all(self.session, hub.name)
+        self.assertEqual(8, len(widgets))
+
+    def test_delete_hubs(self):
+        self.session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
+
+        # verify the hub exists
+        hub_name = 'ralph'
+        hub = hubs.models.Hub.get(self.session, hub_name)
+        self.assertIsNotNone(hub)
+
+        # check if association exists
+        username = 'ralph'
+        openid = '%s.id.fedoraproject.org' % username
+        user = hubs.models.User.get(self.session, openid)
+        assoc = hubs.models.Association.get(self.session, hub, user, 'owner')
+        self.assertIsNotNone(assoc)
+
+        # check if widgets exist
+        widgets = hubs.models.Widget.by_hub_id_all(self.session, hub.name)
+        self.assertEqual(8, len(widgets))
+
+        # delete the hub
+        self.session.delete(hub)
+
+        # check if association is removed
+        assoc = hubs.models.Association.get(self.session, hub, user, 'owner')
+        self.assertIsNone(assoc)
+
+        # check if widgets are removed
+        widgets = hubs.models.Widget.by_hub_id_all(self.session, hub.name)
+        self.assertEqual([], widgets)
+
+        # verify hub is deleted
+        hub = hubs.models.Hub.get(self.session, hub_name)
+        self.assertIsNone(hub)
+
+        # check if user is still intact
+        user = hubs.models.User.get(self.session, openid)
+        self.assertIsNotNone(user)
+        self.assertIn('ralph', user.openid)
+
+    def test_delete_user_then_hubs(self):
+        self.session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
+        username = 'ralph'
+        openid = '%s.id.fedoraproject.org' % username
+        user = hubs.models.User.get(self.session, openid)
+        self.assertIsNotNone(user)
+        self.session.delete(user)
+        user = hubs.models.User.get(self.session, openid)
+        self.assertIsNone(user)
+
+        # checking to see if the hub is still intact
+        hub = hubs.models.Hub.get(self.session, username)
+        self.assertIsNotNone(hub)
+
+        self.session.delete(hub)
+
+        # check if widgets are removed
+        widgets = hubs.models.Widget.by_hub_id_all(self.session, hub.name)
+        self.assertEqual([], widgets)
+
+        hub = hubs.models.Hub.get(self.session, username)
+        self.assertIsNone(hub)

